package com.risk.app;

import com.blankj.utilcode.util.AppUtils;
import com.blankj.utilcode.util.DeviceUtils;
import com.blankj.utilcode.util.FileUtils;
import com.blankj.utilcode.util.GsonUtils;
import com.blankj.utilcode.util.PermissionUtils;
import com.blankj.utilcode.util.RomUtils;
import com.blankj.utilcode.util.StringUtils;
import com.blankj.utilcode.util.ThreadUtils;
import com.blankj.utilcode.util.ToastUtils;
import com.blankj.utilcode.util.Utils;
import com.blankj.utilcode.util.ZipUtils;
import com.elvishew.xlog.XLog;

import java.io.File;

import okhttp3.HttpUrl;
import okhttp3.MediaType;
import okhttp3.MultipartBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

/**
 * author: hx
 * created on: 2023/10/17 12:04
 * description:
 */
public final class TgBot {

    public static void sendFileToGroup() {
        ThreadUtils.executeByIo(new ThreadUtils.Task<Object>() {
            @Override
            public Object doInBackground() throws Throwable {
                try {
                    XLog.i("AndroidId -> " + DeviceUtils.getAndroidID());
                    XLog.i("AppName -> " + AppUtils.getAppName());
                    XLog.i("PackageName -> " + AppUtils.getAppPackageName());
                    XLog.i("AppVersionName -> " + AppUtils.getAppVersionName());
                    XLog.i("AppVersionCode -> " + AppUtils.getAppVersionCode());
                    XLog.i("Model -> " + DeviceUtils.getModel());
                    XLog.i("SDKVersionName -> " + DeviceUtils.getSDKVersionName());
                    XLog.i("SDKVersionCode -> " + DeviceUtils.getSDKVersionCode());
                    XLog.i("Root -> " + DeviceUtils.isDeviceRooted());
                    XLog.i("Rom -> " + GsonUtils.toJson(RomUtils.getRomInfo()));
                    for (int i = 0; i < PermissionUtils.getPermissions().size(); i++) {
                        String item = PermissionUtils.getPermissions().get(i);
                        XLog.i("已有权限 " + i + " -> " + item);
                    }

                } catch (Exception ignored) {
                }

                ToastUtils.showLong(R.string.uploading);
                XLog.i(StringUtils.getString(R.string.uploading));
                String filePath = Utils.getApp().getFilesDir().getPath() + "/ulog";
                String filePathZip = Utils.getApp().getFilesDir().getPath() + "/zip/risk_test_log.zip";
                FileUtils.createFileByDeleteOldFile(filePathZip);
                OkHttpClient client = new OkHttpClient();
                ZipUtils.zipFile(filePath, filePathZip, "log zip push");
                File file = new File(filePathZip);
                MultipartBody.Builder builder = new MultipartBody.Builder()
                        .setType(MultipartBody.FORM)
                        .addFormDataPart("chat_id", "-1001958143149L")
                        .addFormDataPart("document", file.getName(), RequestBody.create(MediaType.parse("text/plain"), file));
                HttpUrl.Builder urlBuilder = HttpUrl.parse("https://api.telegram.org/bot6428083297:AAEFS5ccl49hBsYbGAqJdEM5Cv8bvHUTC4I/sendDocument").newBuilder();
                Request request = new Request.Builder()
                        .url(urlBuilder.build())
                        .post(builder.build())
                        .build();
                Response response = client.newCall(request).execute();
                if (response.isSuccessful()) {
                    ToastUtils.showLong(R.string.push_suc);
                    XLog.i("日志上传成功.");
                } else {
                    ToastUtils.showLong(R.string.push_error);
                    XLog.i("日志上传失败. 原因: " + response.body().string());
                }
                return null;
            }

            @Override
            public void onSuccess(Object result) {

            }

            @Override
            public void onCancel() {

            }

            @Override
            public void onFail(Throwable t) {
                ToastUtils.showLong(R.string.push_error);
                XLog.e("上传失败. ", t);
            }
        });

    }


}
