package com.risk.app.base;

import android.content.res.Configuration;
import android.os.Bundle;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.viewbinding.ViewBinding;

public abstract class BaseActivity<T extends ViewBinding> extends AppCompatActivity {
    public T bind;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setLayout();
        initData(savedInstanceState);
        initView();
    }

    protected abstract T getViewBinding();

    public void setLayout() {
        bind = getViewBinding();
        Configuration config = getResources().getConfiguration();
        bind.getRoot().setLayoutDirection(config.getLayoutDirection());
        setContentView(bind.getRoot());
    }

    /**
     * 初始化部分数据
     */
    public abstract void initData(Bundle bundle);

    /**
     * 初始化页面
     */
    public abstract void initView();
}
